'use strict';

// console.info('require url module');

exports.getPageName = getPageName;
exports.getQuery = getQuery;
exports.getHash = getHash;
exports.parse = parseUrl;
exports.serialize = serialize;
exports.apiUrl = apiUrl();
function getPageName() {
    var u = location.pathname;
    var a = u.split(/\//);
    var m = a.pop().match(/(?:^|\/)($|[^\.]+)/);
    return m[1] ? m[1] : 'index';
}

function getQuery (name) {
    let result = location.search.match(new RegExp("[\?\&]" + name+ "=([^\&]+)","i"));
    if(result == null || result.length < 1){
        return "";
    }
    return result[1];
}

function getHash(name) {
    var u = location.hash.slice(1);
    var re = new RegExp(name + '=([^&\\s+]+)');
    var m = u.match(re);
    var v = m ? m[1] : '';

    return (v === '' || isNaN(v)) ? v : v - 0;
}

function parseUrl(url) {
    var a = document.createElement('a');

    a.href = (url || 'x.html');

    return {
        host: a.host,
        protocol: a.protocol
    };
}

function serialize(obj) {
    var s = [];

    $.each(obj, function(k, v) {
        s.push(k + '=' + encodeURIComponent(v));
    });

    return s.join('&');
}

function apiUrl() {
    // location.origin
    // "http://campus.imqq.cn"
    // location.pathname
    // "/dev_m/cloud.html"
    // location.hostname
    // "campus.imqq.cn"
    var apiUrl;
    if (/qq.com/.test(location.origin)) {
        // 线上环境
        apiUrl = ["http://m.campus.qq.com/m/", "http://m.campus.qq.com/"]
    } else {
        if (!/m\//.test(location.pathname)) {
            // 本地开发环境
            // ===================本地开发访问测试API=========================
            // apiUrl = ["http://campus.imqq.cn/m/", "http://campus.imqq.cn/"]
            // ===================本地开发访问开发API=========================
            apiUrl = ["http://campus.imqq.cn/dev_m/", "http://campus.imqq.cn/dev_"]
        } else {
            // 自动匹配 测试环境 或者 开发环境 或者 个人目录
            // apiUrl = ["http://campus.imqq.cn/m/", "http://campus.imqq.cn/"]
            // apiUrl = ["http://campus.imqq.cn/dev_m/", "http://campus.imqq.cn/dev_"]
            apiUrl = /(?:(.*?)(m\/))/.exec(window.location.href)
        }
    }

    return apiUrl
}
